import pyadchpp as adchpp
import Hub
import SettingManager
import CommandManager
import general
import autil
import os

bot = None
msgCMD = None

def makeBot(name="", cid="", desc="", email=""):
    makebot = Hub.ClientMgr.createSimpleBot()
    makebot.setCID(adchpp.CID(cid))
    makebot.setField("ID", cid)
    makebot.setField("NI", name)
    makebot.setField("DE", desc)
    makebot.setField("EM", email)
    makebot.setFlag(adchpp.Entity.FLAG_REGISTERED)
    makebot.setFlag(adchpp.Entity.FLAG_OP)
    makebot.setFlag(adchpp.Entity.FLAG_SU)
    makebot.setFlag(adchpp.Entity.FLAG_OWNER)
    Hub.ClientMgr.regBot(makebot)
    return makebot

def initModule():
    global bot, msgCMD
    SettingManager.add(SettingManager.Setting(key="bot_cid", alias=['botcid'], helpTxt="CID of the bot, restart the hub after the change",value=adchpp.CID.generate().toBase32(), validate=validateCID))
    SettingManager.add(SettingManager.Setting(key="bot_name", alias=['botnick','botni'], change=botNameChange, helpTxt="name of the hub bot",value=adchpp.CID.generate().toBase32(), validate=general.validate_ni))
    SettingManager.add(SettingManager.Setting(key="bot_description", alias=['botdescr','botde'], change=botDescChange, helpTxt="description of the hub bot",value="", validate=general.validate_de))
    SettingManager.add(SettingManager.Setting(key="bot_email", alias=['botmail','botem'], change=botEmailChange, helpTxt="e-mail of the hub bot",value="", validate=general.validate_de))
    bot = makeBot(cid=SettingManager.settings['bot_cid'].value,name=SettingManager.settings['bot_name'].value,desc=SettingManager.settings['bot_description'].value,email=SettingManager.settings['bot_email'].value)

    msgCMD = autil.handleCommand(onMSG, adchpp.AdcCommand.CMD_MSG)
    
def validateCID(new):
    if adchpp.CID(new).isZero():
        return "the CID must be a valid 39-byte base32 representation"

def botNameChange(oldValue, newValue):
    if bot:
        bot.setField("NI", newValue)
        infCMD = adchpp.AdcCommand(adchpp.AdcCommand.CMD_INF, adchpp.AdcCommand.TYPE_BROADCAST, bot.getSID())
        infCMD.addParam("NI", newValue)
        Hub.ClientMgr.sendToAll(infCMD.getBuffer())

def botDescChange(oldValue, newValue):
    if bot:
        bot.setField("DE", newValue)
        infCMD = adchpp.AdcCommand(adchpp.AdcCommand.CMD_INF, adchpp.AdcCommand.TYPE_BROADCAST, bot.getSID())
        infCMD.addParam("DE", newValue)
        Hub.ClientMgr.sendToAll(infCMD.getBuffer())

def botEmailChange(oldValue, newValue):
    if bot:
        bot.setField("EM", newValue)
        infCMD = adchpp.AdcCommand(adchpp.AdcCommand.CMD_INF, adchpp.AdcCommand.TYPE_BROADCAST, bot.getSID())
        infCMD.addParam("EM", newValue)
        Hub.ClientMgr.sendToAll(infCMD.getBuffer())


def onMSG(ent, cmd, ok):
    if cmd.getTo() == bot.getSID():
        result = CommandManager.onMSG(ent, cmd, ok) #Checks to see if user sent command, lets CommandManager handle it if it is
        
        if result:
            ent.send( autil.pm_direct("Hello, I am just a hub bot. If you need help please type !help for available commands or ask an Operator for assistance", bot.getSID(), bot.getSID(), ent.getSID()) )
    
        return False

    return True
