import pyadchpp as adchpp
import Hub
import UserManager
import SettingManager
import CommandManager
import HubBot
import autil
import re

def initModule():    
    addSettings()
    CommandManager.add(CommandManager.Command(key='myip', alias=['getip', 'getmyip','ip','showip','showmyip'], helpTxt="returns your IP", command=(lambda ent, cmd, params, public: autil.hub_reply(ent, "Your IP is: " + ent.asClient().getIp())), user_command =
                                              CommandManager.UserCommand(contexts= CommandManager.context_hub + CommandManager.context_userlist,command='myip', path='ADCH++/myip')))
    CommandManager.add(CommandManager.Command(key='test', helpTxt="- make the hub reply \"Test ok\"", command=(lambda ent, cmd, params, public: autil.hub_reply(ent, "Test ok"))))
    CommandManager.add(CommandManager.Command(key='topic', alias=['changetopic', 'settopic','changehubtopic','sethubtopic'],category="HubManagement", helpTxt="topic - change the hub topic (shortcut to !cfg topic)",command=changeTopic, minLevel=SettingManager.settings['level_op'], user_command =
                                              CommandManager.UserCommand(contexts=CommandManager.context_hub + CommandManager.context_userlist,command='topic ' + CommandManager.createLine("Topic"), path='ADCH++/topic')))
    CommandManager.add(CommandManager.Command(key='kick', alias=['drop', 'dropuser','kickuser'], helpTxt="user [reason] - disconnect the user, she can reconnect whenever she wants to",category="BanManager",command=kick, minLevel=SettingManager.settings['level_op'], user_command =
                                              [CommandManager.UserCommand(contexts= CommandManager.context_userlist,command='kick %[userNI] ' + CommandManager.createLine("Reason (facultative)"), path='ADCH++/Hub management/Punish/Kick'),
                                               CommandManager.UserCommand(contexts= CommandManager.context_hub, command='kick ' + CommandManager.createLine("Nick") + " " + CommandManager.createLine("Reason (facultative)"), path='ADCH++/Hub management/Punish/Kick')]))
    CommandManager.add(CommandManager.Command(key='mass', alias=['massmessage'], helpTxt="message [min-level]",category="HubManagement",command=mass, minLevel=SettingManager.settings['level_op'], user_command =
                                              [CommandManager.UserCommand(contexts= CommandManager.context_userlist+CommandManager.context_hub,command='mass ' + CommandManager.createLine("Message") + " " + CommandManager.createLine("Minimum level (facultative)"), path='ADCH++/Hub management/Mass message')]))
    CommandManager.add(CommandManager.Command(key='redirect', alias=['forward'], helpTxt="nick address - sends user to hub with (address)",category="UserManagement",command=redirectCommand, minLevel=SettingManager.settings['level_op'], user_command =
                                              [CommandManager.UserCommand(contexts= CommandManager.context_userlist,command='redirect %[userNI] ' + CommandManager.createLine("Address"), path='ADCH++/Hub management/Punish/Redirect'),
                                               CommandManager.UserCommand(contexts= CommandManager.context_hub, command='redirect ' + CommandManager.createLine("Nick") + " " + CommandManager.createLine("Address"), path='ADCH++/Hub management/Punish/Redirect')]))

    CommandManager.add(CommandManager.Command(key='shutdownHub', helpTxt="SHUTDOWN - shuts down the hub, be sure to type the security string to process command",category="HubManagement",command=shutdownHubCmd, minLevel=SettingManager.settings['level_op'], user_command =
                                              CommandManager.UserCommand(contexts= CommandManager.context_userlist,command='shutdownHub ' + CommandManager.createLine("Security, type: SHUTDOWN") , path='ADCH++/Hub management/Shutdown Hub')))
    #CommandManager.add(CommandManager.Command(key='restartHub', helpTxt="RESTART - restarts the hub, be sure to type the security string to process command",category="HubManagement",command=restartHubCmd, minLevel=SettingManager.settings['level_op'], user_command =
    #                                          CommandManager.UserCommand(contexts= CommandManager.context_userlist,command='restartHub ' + CommandManager.createLine("Security, type: RESTART") , path='ADCH++/Hub management/Restart Hub')))



def shutdownHubCmd(ent, cmd, params, public):
    if len(params) == 1 and params[0] == "SHUTDOWN":
        Hub.shutdownHub()
    else:
        autil.hub_reply(ent, "Security string not entered, not shutting down. Parameter 1 but be: SHUTDOWN")

#def restartHubCmd(ent, cmd, params, public):
#    if len(params) == 1 and params[0] == "RESTART":
#        Hub.restartHub()
#    else:
#        autil.hub_reply(ent, "Security string not entered, not shutting down. Parameter 1 but be: RESTART")

def changeTopic(ent, cmd, params, public):
    sendStr = "topic"
    if len(params) > 0:
        sendStr += " " + params[0]
    SettingManager.cfgCommand(ent,cmd,[sendStr],public)

def appendTopicHistory():
    if initiated:
        fileLock.acquire()
        if autil.saveJsonFile(users, os.path.join(Hub.CfgDir, usersFile)):
            global saved
            saved = True
        fileLock.release()
    
def addSettings():
    SettingManager.add(SettingManager.Setting(key='address',alias=['host','dns'],helpTxt='host address (DNS or IP)',value=adchpp.Util.getLocalIp()) )
    SettingManager.add(SettingManager.Setting(key='maxusers',alias=['max_users', 'user_max', 'users_max', 'usermax', 'usersmax'],helpTxt="maximum number of non-registered users, -1 = no limit, 0 = no unregistered users allowed", value=-1))
    SettingManager.add(SettingManager.Setting(key='maxnicklength',helpTxt="maximum number of characters allowed per nick, 0 = no limit", value=0))
    SettingManager.add(SettingManager.Setting(key='name',alias=['hubname'],helpTxt="hub name", value=Hub.ClientMgr.getEntity(adchpp.AdcCommand.HUB_SID).getField("NI"),validate=validate_ni))
    SettingManager.add(SettingManager.Setting(key='network',alias=['hubnetwork'],helpTxt="hub network", value=""))
    SettingManager.add(SettingManager.Setting(key='owner',alias=['ownername'],helpTxt="owner name", value=""))
    SettingManager.add(SettingManager.Setting(key='description',alias=['hubdescription'],helpTxt='hub description',value=Hub.ClientMgr.getEntity(adchpp.AdcCommand.HUB_SID).getField("DE")))
    SettingManager.add(SettingManager.Setting(key='topic',alias=['hubtopic'],helpTxt="hub topic: if set, overrides the description for normal users; the description is only for use by hub-lists",value="", change=changeDesc, validate=validate_de))
    SettingManager.add(SettingManager.Setting(key='website',alias=['url'],helpTxt="hub website",value=""))

def kick(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a nick")
        return

    nick = params.group(1)
    reason = params.group(2)

    victim = Hub.ClientMgr.findByNick(nick)
    if victim:
        victim = victim.asClient()
    if not victim:
        autil.hub_reply(ent, "No user named \"" + nick + "\"")
        return

    victim_cid = victim.getCID().toBase32()
    victim_user = UserManager.findUser(nick, victim_cid)
    if victim_user and level <= victim_user.level:
        autil.hub_reply(ent, "You can't kick users whose level is higher or equal than yours")
        return
    
    txt = "You have been kicked"
    if reason:
        txt += " (reason: " + reason + ")"
    autil.dump(victim, adchpp.AdcCommand.ERROR_BANNED_GENERIC, adchpp.Util.REASON_PLUGIN, (lambda cmd: cmd.addParam("ID", adchpp.AdcCommand.fromSID(ent.getSID())).addParam("MS",txt)))
    autil.ent_reply_ME(ent, 'has kicked "' + nick + '" (' + reason + ')')
    return

def redirectCommand(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a nick and an address")
        return

    nick = params.group(1)
    address = params.group(2)

    if not nick or not address:
        autil.hub_reply(ent, "You need to supply a nick and an address")
        return

    victim = Hub.ClientMgr.findByNick(nick)
    if victim:
        victim = victim.asClient()
    if not victim:
        autil.hub_reply(ent, "No user named \"" + nick + "\"")
        return

    victim_cid = victim.getCID().toBase32()
    victim_user = UserManager.findUser(nick, victim_cid)
    if victim_user and level <= victim_user.level:
        autil.hub_reply(ent, "You can't redirect users whose level is higher or equal than yours")
        return

    autil.hub_reply(victim, "You have been redirected to \"" + address + "\"")
    autil.dump(victim, adchpp.AdcCommand.ERROR_BANNED_GENERIC, adchpp.Util.REASON_PLUGIN, (lambda cmd: cmd.addParam("RD", address)))
    autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") has been redirected to \"" + address + "\"")
    return


def mass(ent, cmd, params, public):
    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    level_search = re.search("\s(\d*)$", params)
    level = 0

    if level_search and len(level_search.group(0)) != 0:
        params = params[0:len(params)-len(level_search.group(0))]
        level = int(level_search.group(1))
            
        if len(params) <= 0:
            autil.hub_reply(ent, "Bad arguments")
            return

    entities = Hub.ClientMgr.getEntities()
    if not entities:
        return

    mass_cmd = None;
    if HubBot.bot:
        mass_cmd = autil.pm_direct(params, HubBot.bot.getSID(), HubBot.bot.getSID(), None)
    else:
       mass_cmd = autil.info(params)

    count = 0
    for entity in entities:
        other = entity.asClient()
        if other:
            if level == 0 or UserManager.getLevel(entity) > level:
                mass_cmd.setTo(other.getSID())
                other.send(mass_cmd)
                count+=1

    autil.hub_reply(ent, "Message sent to " + str(count) + " users")

def recheck_info():
    entities = Hub.ClientMgr.getEntities()
    if len(entities) > 0:
        for ent in entities:
            c = ent.asClient()
            if c:
                AccessHandle.verify_info(c)

def changeDesc(oldValue, newValue):
    desc = newValue
    if len(desc) == 0:
        if 'description' in SettingManager.settings:
            desc = SettingManager.settings['description'].value
        elif 'topic' in SettingManager.settings:
            desc = SettingManager.settings['topic'].value
        else:
            return
            
    desc = str(desc)
    Hub.ClientMgr.getEntity(adchpp.AdcCommand.HUB_SID).setField("DE",desc)
    cmd = adchpp.AdcCommand(adchpp.AdcCommand.CMD_INF,adchpp.AdcCommand.TYPE_INFO, adchpp.AdcCommand.HUB_SID)
    cmd.addParam("DE",desc)
    Hub.ClientMgr.sendToAll(cmd.getBuffer())
    brodcastStr = 'The topic has been changed to: ( ' + desc + ' )'
    if hasattr(autil.threadData, 'origUser'):
        brodcastStr+= ", by: " + autil.threadData.origUser.nick
    autil.hub_broadcast(brodcastStr);

def validate_ni(new):
    for char in new:
        if ord(char) <= 32:
                return("the name can't contain any space nor new line")

def validate_de(new):
    for char in new:
        if ord(char) < 32:
                return("the description can't contain any new line nor tabulation")